"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ReportedStructuralVariantCancer(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "alternate",
        "chromosome",
        "end",
        "reference",
        "start",
        "type",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_2_1_0 import reports as reports_2_1_0

        return {
            "Gel_BioInf_Models.ReportedStructuralVariantCancer": reports_2_1_0.ReportedStructuralVariantCancer,
        }

    __slots__ = [
        "alternate",
        "chromosome",
        "end",
        "reference",
        "start",
        "type",
        "additionalNumericVariantAnnotations",
        "additionalTextualVariantAnnotations",
        "comments",
    ]

    def __init__(
        self,
        alternate,
        chromosome,
        end,
        reference,
        start,
        type,
        additionalNumericVariantAnnotations=None,
        additionalTextualVariantAnnotations=None,
        comments=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_2_1_0.ReportedStructuralVariantCancer model.

        :param alternate:
            alternate: Alternate Allele sequence, the same provided in vcf
        :type alternate: str
        :param chromosome:
            chromosome, named as: 1-22,X,Y,MT(other contigs name)
        :type chromosome: str
        :param end:
            end: end position 1-based
        :type end: int
        :param reference:
            reference: Reference Allele sequence, the same provided in vcf
        :type reference: str
        :param start:
            start: start position 1-based
        :type start: int
        :param type:
            The ID field indicates the type of structural variant, and can be a
            colon-separated list of types and subtypes     (this is
            VCF Format): DEL, INS, DUP, INV, CNV, DUP:TANDEM, DEL:ME,
            INS:ME, INS:ME:ALU...
        :type type: str
        :param additionalNumericVariantAnnotations:
            For Example (Allele Frequency, sift, polyphen, mutationTaster, CADD.
            ..)
        :type additionalNumericVariantAnnotations: None | dict[str, float]
        :param additionalTextualVariantAnnotations:
            For example HGMD ID)
        :type additionalTextualVariantAnnotations: None | dict[str, str]
        :param comments:
            Comments
        :type comments: None | list[str]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.1.0"
